<?php
/**
 * /admin/includes/modules/payment/quickpay.php
 *
 * Copyright (c) 2014 Stokersoft (info@stokersoft.com)
 * Based on PayFast module for Tomatocart
 * 
 * This payment module is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 3 of the License, or (at
 * your option) any later version.
 * 
 * This payment module is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 * 
 * Version 1.0
 */
 
/**
 * The administration side of the QuickPay payment module
 */

  class osC_Payment_quickpay extends osC_Payment_Admin {

/**
 * The administrative title of the payment module
 *
 * @var string
 * @access private
 */
  var $_title;
  
/**
 * The code of the payment module
 *
 * @var string
 * @access private
 */

  var $_code = 'quickpay';
  
/**
 * The developers name
 *
 * @var string
 * @access private
 */

  var $_author_name = 'Asad Khan';
  
/**
 * The developers address
 *
 * @var string
 * @access private
 */  
  
  var $_author_www = 'https://www.code-studios.com';
  
/**
 * The status of the module
 *
 * @var boolean
 * @access private
 */

  var $_status = false;
  
/**
 * Constructor
 */

  function osC_Payment_quickpay() {
    global $osC_Language;
    
    $this->_title = $osC_Language->get('payment_quickpay_title');
    $this->_description = $osC_Language->get('payment_quickpay_description');
    $this->_method_title = $osC_Language->get('payment_quickpay_method_title');
    $this->_status = (defined('MODULE_PAYMENT_QUICKPAY_STATUS') && (MODULE_PAYMENT_QUICKPAY_STATUS == '1') ? true : false);
    $this->_sort_order = (defined('MODULE_PAYMENT_QUICKPAY_SORT_ORDER') ? MODULE_PAYMENT_QUICKPAY_SORT_ORDER : null);
  }
  
/**
 * Checks to see if the module has been installed
 *
 * @access public
 * @return boolean
 */

  function isInstalled() {
    return (bool)defined('MODULE_PAYMENT_QUICKPAY_STATUS');
  }
  
/**
 * Installs the module
 *
 * @access public
 * @see osC_Payment_Admin::install()
 */

  function install() {
    global $osC_Database, $osC_Language;
      
    parent::install();
    
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('* Enable QuickPay Website Payments', 'MODULE_PAYMENT_QUICKPAY_STATUS', '-1', 'Do you want to accept QuickPay Website Payments payments?', '6', '0', 'osc_cfg_set_boolean_value(array(1, -1))', now())");
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('* QuickPay Merchant ID', 'MODULE_PAYMENT_QUICKPAY_MERCHANT_ID', '0', 'The seller Merchant ID provided by QuickPay to accept payments.', '6', '0', now())");
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('* Payment Window Api Key', 'MODULE_PAYMENT_QUICKPAY_MERCHANT_KEY', '0', 'The seller Merchant Key provided by QuickPay to accept payments.', '6', '0', now())");
    
    
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('* API Key', 'MODULE_PAYMENT_QUICKPAY_API_KEY', '0', 'The seller API Key provided by QuickPay to accept payments.', '6', '0', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('* Private Key', 'MODULE_PAYMENT_QUICKPAY_PRIVATE_KEY', '0', 'The seller Private Key provided by QuickPay to accept payments.', '6', '0', now())");
           $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('* Agreement ID', 'MODULE_PAYMENT_QUICKPAY_AGREEMENT_ID', '0', 'The seller Agreement ID provided by QuickPay to accept payments.', '6', '0', now())");

      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values (' Subscription', 'MODULE_PAYMENT_QUICKPAY_SUBSCRIPTION', '', 'Select Subscription', '6', '0', 'osc_cfg_set_boolean_value(array(\'Standard Payment\', \'Subscription\'))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values (' Description', 'MODULE_PAYMENT_QUICKPAY_DESCRIPTION', '', 'Please enter description.', '6', '0', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Language', 'MODULE_PAYMENT_QUICKPAY_LANGUAGE', 'English', 'Select Language', '6','0', 'osc_cfg_set_boolean_value(array(\'Danish\',\'German\',\'English\',\'Danish\',\'Faeroese\',\'French\',\'Greenlandish\',\'Italian\',\'Norwegian\',\'Dutch\',\'Polish\',\'Swedish\'))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Auto FEE', 'MODULE_PAYMENT_QUICKPAY_AUTOFEE', 'No', 'AUTOFEE', '6','0', 'osc_cfg_set_boolean_value(array(\'Yes\', \'No\'))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Autocapture', 'MODULE_PAYMENT_QUICKPAY_AUTOCAPTURE', 'No', 'Autocapture', '6','0', 'osc_cfg_set_boolean_value(array(\'Yes\', \'No\'))', now())");
      $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment Method', 'MODULE_PAYMENT_QUICKPAY_PAYMENT_METHOD', 'creditcard', 'Payment Method', '6', '0', now())");
        $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Order Prefix', 'MODULE_PAYMENT_QUICKPAY_ORDER_PREFIX', '', 'Payment Method', '6', '0', now())");
        $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Branding ID', 'MODULE_PAYMENT_QUICKPAY_BRANDING_ID', '', 'Branding ID', '6', '0', now())");
        $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Google Analytics Tracking ID', 'MODULE_PAYMENT_QUICKPAY_GOOGLE_TRACKING_ID', '', 'Enter Google Analytics Tracking ID', '6', '0', now())");
        $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Google Analytics Client ID', 'MODULE_PAYMENT_QUICKPAY_GOOGLE_ANALYTICS_CLIENT_ID', '', 'Enter Google Analytics Client ID', '6', '0', now())");
        $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Paii Product ID', 'MODULE_PAYMENT_QUICKPAY_PAII_PRODUCT_ID', '', 'Enter Paii Product ID', '6', '0', now())");
        $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Paii Category ID', 'MODULE_PAYMENT_QUICKPAY_PAII_CATEGORY_ID', '', 'Enter Paii Category ID', '6', '0', now())");

    
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_QUICKPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_QUICKPAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '0', 'osc_cfg_use_get_zone_class_title', 'osc_cfg_set_zone_classes_pull_down_menu', now())");
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('* Set Processing Order Status', 'MODULE_PAYMENT_QUICKPAY_PROCESSING_ORDER_STATUS_ID', '" . ORDERS_STATUS_PROCESSING . "', 'When the customer is returned to the Checkout Complete page from QuickPay, this order status should be used', '6', '0', 'osc_cfg_set_order_statuses_pull_down_menu', 'osc_cfg_use_get_order_status_title', now())");
    $osC_Database->simpleQuery("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('* Set QuickPay Acknowledged Order Status', 'MODULE_PAYMENT_QUICKPAY_ORDER_STATUS_ID', '" . ORDERS_STATUS_PAID . "', 'When the QuickPay payment is successfully made, this order status should be used', '6', '0', 'osc_cfg_set_order_statuses_pull_down_menu', 'osc_cfg_use_get_order_status_title', now())");

  }

/**
 * Return the configuration parameter keys in an array
 *
 * @access public
 * @return array
 */

  function getKeys() {
    if (!isset($this->_keys)) {
      $this->_keys = array('MODULE_PAYMENT_QUICKPAY_STATUS', 
                           'MODULE_PAYMENT_QUICKPAY_MERCHANT_ID',
                           'MODULE_PAYMENT_QUICKPAY_MERCHANT_KEY', 
          
                          'MODULE_PAYMENT_QUICKPAY_API_KEY',
          'MODULE_PAYMENT_QUICKPAY_PRIVATE_KEY',
          'MODULE_PAYMENT_QUICKPAY_AGREEMENT_ID',
          'MODULE_PAYMENT_QUICKPAY_SUBSCRIPTION',
          'MODULE_PAYMENT_QUICKPAY_DESCRIPTION',
          'MODULE_PAYMENT_QUICKPAY_LANGUAGE',
          'MODULE_PAYMENT_QUICKPAY_AUTOFEE',
          'MODULE_PAYMENT_QUICKPAY_AUTOCAPTURE',
          'MODULE_PAYMENT_QUICKPAY_PAYMENT_METHOD',
          'MODULE_PAYMENT_QUICKPAY_ORDER_PREFIX',
          'MODULE_PAYMENT_QUICKPAY_BRANDING_ID',
          'MODULE_PAYMENT_QUICKPAY_GOOGLE_TRACKING_ID',
          'MODULE_PAYMENT_QUICKPAY_GOOGLE_ANALYTICS_CLIENT_ID',
          'MODULE_PAYMENT_QUICKPAY_PAII_PRODUCT_ID',
          'MODULE_PAYMENT_QUICKPAY_PAII_CATEGORY_ID',
          
                           'MODULE_PAYMENT_QUICKPAY_ZONE',
                           'MODULE_PAYMENT_QUICKPAY_PROCESSING_ORDER_STATUS_ID',
                           'MODULE_PAYMENT_QUICKPAY_ORDER_STATUS_ID', 
                           'MODULE_PAYMENT_QUICKPAY_SORT_ORDER',
                           );
    }
  
    return $this->_keys;
 } 
}
?>
